﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.32
@EndOfDesignText@
Sub Class_Globals
	Private baseUrl As String
	Private bottoken As String
	Private callbac As Object
	Private evname As String
	Public FILE_API As String  = "https://api.telegram.org/file/bot"
	Private apiUrl As String
End Sub




Public Sub  getFullFilePath( filePath As String) As String
	Dim slash As  Int  = filePath.lastIndexOf("/") + 1
	Dim path As String = filePath.substring2(0, slash)
	Dim fileName As String  = filePath.substring(slash)
	Try
		Dim su  As  StringUtils
		Return apiUrl & path & su.EncodeUrl(fileName, "UTF-8").replace("+", "%20")
	Catch
		Log(LastException)
		Return apiUrl & filePath
	End Try
End Sub
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(token As String,callback As Object,EventName As String)
	callbac= callback
	evname =EventName
	bottoken=token
	baseUrl = "https://api.telegram.org/bot"&bottoken
	apiUrl = FILE_API & token & "/"
End Sub
Public Sub GetFile(file_id As String)
	Dim j As HttpJob
	j.Initialize("GetFile",Me)
	Log(baseUrl&"/getFile")
	j.Download2(baseUrl&"/getFile",Array As String("file_id",file_id))
End Sub
Public Sub GetMe
	Dim j As HttpJob
	j.Initialize("GetMe",Me)
	Log(baseUrl&"/getMe")
	j.Download(baseUrl&"/getMe")
End Sub
Public Sub getUpdates(offset As Int,limit As Int,timeout As Int ,allowed_updates As String)

	Dim j As HttpJob
	j.Initialize("getUpdates",Me)
	Dim gsn As JSONGenerator
	gsn.Initialize(CreateMap("offset":offset,"limit":limit,"timeout":timeout,"allowed_updates":allowed_updates))
	j.PostString(baseUrl&"/getUpdates",gsn.ToString)
End Sub
Sub JobDone(job As HttpJob)
	
	If job.Success Then
		Log(job.GetString)
		Select job.JobName

		
		Case "GetFile"
			Dim fjn As JSONParser
			fjn.Initialize(job.GetString)
			Dim fmap As Map = fjn.NextObject.Get("result")
			Dim f As TGFile
			f.Initialize(fmap)
			If SubExists(callbac,evname&"_file") Then
					CallSub2(callbac,evname&"_file",f)
			End If
		Case "GetMe"
			Dim u As User
		
			Dim jn As JSONParser
			jn.Initialize(job.GetString)
			Dim umap As Map = jn.NextObject.Get("result")
			u.Initialize(umap)
			If SubExists(callbac,evname&"_me") Then
					CallSub2(callbac,evname&"_me",u)
			End If
				
'			Log(job.GetString)
		Case "GetWebhookInfo"
				Dim jn As JSONParser
				jn.Initialize(job.GetString)
				Dim umap As Map = jn.NextObject
				
				Dim whi As WebhookInfo
				whi.Initialize(umap.Get("result"))
				If SubExists(callbac,evname&"_webhookinfo") Then
					CallSub2(callbac,evname&"_webhookinfo",whi)
				End If
				
		Case "SetWebhook"
'				Log(job.GetString)
		Case "getUpdates"
				Dim jn As JSONParser
				jn.Initialize(job.GetString)
				Dim umap As Map = jn.NextObject
				Dim updates As List=umap.Get("result")
				Dim myupdates As List
				myupdates.Initialize
				For  up = 0 To updates.Size-1

					Dim updatey As Update
					updatey.Initialize(updates.Get(up))
					myupdates.Add(updatey)

				Next
				
				If SubExists(callbac,evname&"_updates") Then
					CallSub2(callbac,evname&"_updates",myupdates)
				End If
				
		End Select
'		
		
	Else
		Log("Error in job "&job.JobName&" : "&job.ErrorMessage)
	End If
	
	
	
	
	job.Release
End Sub

Public Sub GetWebhookInfo
	Dim hookjob As HttpJob
	hookjob.Initialize("GetWebhookInfo",Me)
	hookjob.Download(baseUrl&"/getWebhookInfo")
End Sub
Public Sub DeleteWebhook(url As String)
	Dim hookjob As HttpJob
	hookjob.Initialize("DeleteWebhook",Me)
	hookjob.Download2(baseUrl&"/deleteWebhook",Array As String("url",url))
End Sub
Public Sub SetWebhook(url As String)
	Dim hookjob As HttpJob
	hookjob.Initialize("SetWebhook",Me)
	hookjob.Download2(baseUrl&"/setWebhook",Array As String("url",url))
End Sub